
/*
 * ELEMENT.H	generation of DSP simulation elements
 */


#ifndef _ELEMENT_H_
#define _ELEMENT_H_


#include "tree.h"


#define STACKSIZE	5000	/* macro expansion stack size */


#define E_CONSTANT	0
#define E_CONNECT	1
#define E_ADD		2
#define E_SUB		3
#define E_MUL		4
#define E_DIV		5
#define E_DELAY		6
#define E_PROBE		7
#define E_STEP		8
#define E_SIN		9
#define E_COS		10
#define E_ATAN		11
#define E_SQRT		12

typedef struct element {
  int type;
  union {
    struct {
      double value;
      int out;
    } constant;
    struct {
      int in;
      int out;
    } connect;
    struct {
      int op1;
      int op2;
      int out;
    } arith;
    struct {
      int in;
      int out;
      double state;		/* these are the DSP state variables */
      struct element *next;	/* all delays are linked into a list */
    } delay;
    struct {
      int in1;
      int in2;
      int in3;
      int in4;
    } probe;
    struct {
      int in;
      int out;
    } step;
    struct {
      int in;
      int out;
    } sin;
    struct {
      int in;
      int out;
    } cos;
    struct {
      int in_y;
      int in_x;
      int out;
    } atan;
    struct {
      int in;
      int out;
    } sqrt;
  } u;
  struct element *next;
} ELEMENT;


ELEMENT *gen_elements(NODE *nodelist);
void show_element(ELEMENT *element);
void show_elements(ELEMENT *elements);


#endif /* _ELEMENT_H_ */
