
/*
 * SYMTBL.H	symbol table management
 */


#ifndef _SYMTBL_H_
#define _SYMTBL_H_


#include "tree.h"


typedef struct symbol {
  char *name;
  union {
    NODE *node;
    int number;
  } info;
  struct symbol *next;
} SYMBOL;


void init_builtins(void);
SYMBOL *lookup_builtin(char *name);

void init_macros(void);
SYMBOL *lookup_macro(char *name);
SYMBOL *enter_macro(char *name, NODE *macro);
void show_macros(void);

void init_global_signals(void);
SYMBOL *lookup_global_signal(char *name);
SYMBOL *enter_global_signal(char *name);
char *nameof_global_signal(int signal_number);
int get_number_global_signals(void);

void init_params(void);
SYMBOL *lookup_param(char *name);
SYMBOL *enter_param(char *name);
int get_number_params(void);

void init_local_signals(void);
SYMBOL *lookup_local_signal(char *name);
SYMBOL *enter_local_signal(char *name);
int get_number_local_signals(void);


#endif /* _SYMTBL_H_ */
