/*
 * design.c	PLL design help program
 */


#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define PI	M_PI


int main(void) {
  double fn, zeta, fs;
  double wn, tau2, tau1, alpha;
  double gamma, b0, b1, a1, k;

  printf("Please enter fn: ");
  fflush(stdout);
  scanf("%le", &fn);
  printf("Please enter zeta: ");
  fflush(stdout);
  scanf("%le", &zeta);
  printf("Please enter fs: ");
  fflush(stdout);
  scanf("%le", &fs);

  wn = 2 * PI * fn;
  tau2 = (2 * zeta - 1) / wn;
  printf("tau2 = %e sec\n", tau2);
  tau1 = 1 / wn - tau2;
  printf("tau1 = %e sec\n", tau1);
  alpha = tau2 / (tau1 + tau2);
  gamma = 1 / tan(1 / (2 * fs * (tau1 + tau2)));
  printf("gamma = %e\n", gamma);

  b0 = (1 + alpha * gamma) / (1 + gamma);
  printf("b0 = %e\n", b0);
  b1 = (1 - alpha * gamma) / (1 + gamma);
  printf("b1 = %e\n", b1);
  a1 = (1 - gamma) / (1 + gamma);
  printf("a1 = %e\n", a1);
  k = wn / fs;
  printf("k = %e\n", k);
  return 0;
}
